// ScreenMode.h
#pragma once

// what : DirectX gȂAvP[VpAEBhẼtXN[؂ւNXB
// who  : LaLa Moo-Moo (ITAGAKI Takahiro) mailto:t_itagaki@sannet.ne.jp
// when : 2002/05/01

//  RXgN^ 
// width  : XN[̕
// height : XN[̍
// minbpp : ŏ̐Fiminbppȏ̐F̃[h񋓂j
// menuID : menuID ` menuID + 100 ܂ł͗\񂳂
// notifyMessageID : [hύXꂽƂɑ郁bZ[W
//     (BOOL)wParam     : ύX̃[hEBhEȂ TRUE AtXN[Ȃ FALSE łB
//     (DEVMODE*)lParam : ݂̃[h܂BEBhE[h̏ꍇNULLłB
//
//  EBhEbZ[W 
// CEBhẼEBhEvV[WŁAScreenMode::OnMessage()ĂŉB
// TRUE  Ԃꍇ́Aʏ̏iȂ̃R[h and/or DefWindowProc()jsĂB
// FALSE Ԃꍇ́Ȃ̏s킸AlResultEBhEvV[W̕ԒlƂĂB
//
//  [hύXj[ 
// EBhE\
// ftHgtXN[[h
// ̑̉ʃ[h
// @640x480 16bpp 60Hz Ȃ
// @cc
// Ƃт̃j[쐬܂B
// 쐬́ACfbNXɂǗsȂ̂ŁAj[ύXĂ܂܂B
// ̃j[pIDƂāAmenuID ` menuID+100 gp܂B

//  j[p̕\ev[g 
const TCHAR* const MENU_WINDOWED_TEXT	= TEXT("EBhE\(&W)");
const TCHAR* const MENU_FULLSCREEN_TEXT	= TEXT("tXN[\ [%dx%d %dbpp %dHz] (&F)"); // w, h, bpp, Hz
const TCHAR* const MENU_OTHERMODE_TEXT	= TEXT("̑̉ʃ[h(&O)");
const TCHAR* const MENU_CUSTOMMODE_TEXT	= TEXT("%dbpp %dHz"); // bpp, Hz

#include <vector>
//
class ScreenMode
{
private:
	typedef std::vector<DEVMODE>	ModeList;
	DEVMODE		m_DefaultMode;	// ftHg̃tXN[[h
	ModeList	m_ModeList;		// p\ȃXN[[h
	BOOL		m_IsWindowed;	// EBhE[hۂ
	HWND		m_hWnd;			// CEBhE
	HMENU		m_hMenu;		// EBhEOj[
	RECT		m_WndRect;		// EBhĚ̈ʒu
	DWORD		m_WndStyle, m_WndExStyle;	// EBhĚ̃X^C
	HMENU		m_hModeMenu;	// ʃ[hj[
public:
	const UINT	WIDTH;
	const UINT	HEIGHT;
	const UINT	MINBPP;
	const UINT	FIRST_MENU;
	const UINT	LAST_MENU;
	const UINT	MENU_WINDOWED;
	const UINT	MENU_FULLSCREEN;
	const UINT	MENU_CUSTOM;
	const UINT	NOTIFY_MESSAGE;
public:
	ScreenMode(UINT width, UINT height, UINT minbpp, UINT menuID, UINT notifyMessage = 0);
	// EBhE[hۂԂB
	BOOL	IsWindowed() const		{return m_IsWindowed;}
	// tXN[[hۂԂB
	BOOL	IsFullScreen() const	{return !m_IsWindowed;}
	// [hύXj[̃nhԂB
	HMENU	GetModeMenu() const		{return m_hModeMenu;}
	// tXN[[hɕύXB
	BOOL	SetFullScreen()			{return ChangeMode(&m_DefaultMode);}
	// EBhE[hɕύXB
	BOOL	SetWindowed()			{return ChangeMode(NULL);}
	// tXN[[h^EBhE[h؂ւB
	BOOL	ToggleMode()			{return IsWindowed() ? SetFullScreen() : SetWindowed();}
	// w肳ꂽDEVMODEŃtXN[[hɕύXBNULL̏ꍇ̓EBhE[hɕύXB
	BOOL	ChangeMode(const DEVMODE* mode);
	// EBhEvV[WtbNĂB
	BOOL	OnMessage(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam, LRESULT& lResult);

private:
	void	SaveWindowState(HWND hWnd);
	void	RestoreWindowState();
	void	SaveMenu();
	void	RestoreMenu();
};
